/**
 *  Supercompilation of calculation of sin(x)
 *  Calculation sin(x) through decomposition
 *  sin(x) = x - x^3/3! + x^5/5! - x^7/7! + ...
 *  The return order of addition.
 */
public class Sn {
//    public static final int iters = 200; /* 2*Quantity of addition*/
    public static final int iters = 2000; /* 2*Quantity of addition*/


    public static void main (String[] args) {
        int iprint1 = 5;
        int iprint = 100000;

        for (int ip = 0; ip < iprint1; ip++) {
            long start = System.currentTimeMillis();

            double x = 3.141592653589793D / 6;
            double res = 0.0;

            for (int i = 0; i < iprint; i++) {
                res = sin(x);
            }

            System.out.println("x      = " + x);
            System.out.println("sin(x) = " + res);
       
            long end = System.currentTimeMillis();
            System.out.println("Total time = "+ (end-start)*0.001);
        }
    }

    public static double sin(double x) {
        return sin1(x, x, 2, 1.0);
    }


    /** One step of calculation sin(x)
      * @param double x    - argument sin(x)
      * @param double x2n  - x^(2*n+1)
      * @param int step    - 2*n
      * @param double znam - +-1/(2*n+1)! 
      */
    public static double sin1(double x, double x2n, int step, double znam) {
        if (step==iters) return 0.0;
          else return sin1(x, x2n*x*x, step+2, -znam/(step*(step+1)))
                      + x2n*znam;
    }
} 
               
        

         